import { CommandInstanceInfo, CommandMetadataOption, IShellRunOptions } from '../../definitions';
import { Command } from '../../lib/command';
export declare const COMMON_CORDOVA_BUILD_COMMAND_OPTIONS: CommandMetadataOption[];
export declare const CORDOVA_BUILD_EXAMPLE_COMMANDS: string[];
export declare abstract class CordovaCommand extends Command {
    checkCordova(runinfo: CommandInstanceInfo): Promise<void>;
    preRunChecks(runinfo: CommandInstanceInfo): Promise<void>;
    runCordova(argList: string[], { fatalOnNotFound, truncateErrorOutput, ...options }?: IShellRunOptions): Promise<void>;
    checkForPlatformInstallation(platform: string, { promptToInstall, promptToInstallRefusalMsg }?: {
        promptToInstall?: boolean;
        promptToInstallRefusalMsg?: string;
    }): Promise<void>;
}
