import { App, AppAssociation, AssociationType, IClient, IPaginator, PaginateArgs, PaginatorState, ResourceClientCreate, ResourceClientLoad, ResourceClientPaginate, Response } from '../definitions';
import { ResourceClient } from './http';
export declare function formatName(app: Pick<App, 'name' | 'org'>): string;
export interface AppClientDeps {
    readonly client: IClient;
    readonly token: string;
}
export interface AppCreateDetails {
    name: string;
}
export declare class AppClient extends ResourceClient implements ResourceClientLoad<App>, ResourceClientCreate<App, AppCreateDetails>, ResourceClientPaginate<App> {
    protected client: IClient;
    protected token: string;
    constructor({ client, token }: AppClientDeps);
    load(id: string): Promise<App>;
    create({ name }: AppCreateDetails): Promise<App>;
    paginate(args?: Partial<PaginateArgs<Response<App[]>>>): IPaginator<Response<App[]>, PaginatorState>;
    createAssociation(id: string, association: {
        repoId: number;
        type: AssociationType;
        branches: string[];
    }): Promise<AppAssociation>;
    deleteAssociation(id: string): Promise<void>;
}
