import { TreatableAilment } from '../../../definitions';
import { Ailment } from './base';
export * from './base';
export * from './utils';
export declare class NpmInstalledLocally extends Ailment implements TreatableAilment {
    readonly id: string;
    readonly treatable: boolean;
    getMessage(): Promise<string>;
    detected(): Promise<boolean>;
    getTreatmentSteps(): Promise<{
        message: string;
        treat: () => Promise<void>;
    }[]>;
}
export declare class IonicCLIInstalledLocally extends Ailment implements TreatableAilment {
    readonly id: string;
    readonly treatable: boolean;
    getMessage(): Promise<string>;
    detected(): Promise<boolean>;
    getTreatmentSteps(): Promise<{
        message: string;
        treat: () => Promise<void>;
    }[]>;
}
export declare class GitNotUsed extends Ailment {
    readonly id: string;
    getMessage(): Promise<string>;
    detected(): Promise<boolean>;
    getTreatmentSteps(): Promise<{
        message: string;
    }[]>;
}
export declare class GitConfigInvalid extends Ailment {
    readonly id: string;
    getMessage(): Promise<string>;
    detected(): Promise<boolean>;
    getTreatmentSteps(): Promise<{
        message: string;
    }[]>;
}
export declare class IonicNativeOldVersionInstalled extends Ailment {
    readonly id: string;
    getMessage(): Promise<string>;
    detected(): Promise<boolean>;
    getTreatmentSteps(): Promise<{
        message: string;
    }[]>;
}
export declare class UnsavedCordovaPlatforms extends Ailment {
    readonly id: string;
    getMessage(): Promise<string>;
    detected(): Promise<boolean>;
    getTreatmentSteps(): Promise<{
        message: string;
    }[]>;
}
export declare class DefaultCordovaBundleIdUsed extends Ailment {
    readonly id: string;
    getMessage(): Promise<string>;
    detected(): Promise<boolean>;
    getTreatmentSteps(): Promise<{
        message: string;
    }[]>;
}
export declare class ViewportFitNotSet extends Ailment {
    readonly id: 'viewport-fit-not-set';
    getMessage(): Promise<string>;
    detected(): Promise<boolean>;
    getTreatmentSteps(): Promise<{
        message: string;
    }[]>;
}
export declare class CordovaPlatformsCommitted extends Ailment {
    readonly id: string;
    getMessage(): Promise<string>;
    detected(): Promise<boolean>;
    getTreatmentSteps(): Promise<{
        message: string;
    }[]>;
}
