import { AngularServeOptions, CommandLineInputs, CommandLineOptions, CommandMetadata, ServeDetails } from '../../../definitions';
import { ServeCLI, ServeRunner, ServeRunnerDeps } from '../../serve';
import { AngularProject } from './';
export interface AngularServeRunnerDeps extends ServeRunnerDeps {
    readonly project: AngularProject;
}
export declare class AngularServeRunner extends ServeRunner<AngularServeOptions> {
    protected readonly e: AngularServeRunnerDeps;
    constructor(e: AngularServeRunnerDeps);
    getCommandMetadata(): Promise<Partial<CommandMetadata>>;
    createOptionsFromCommandLine(inputs: CommandLineInputs, options: CommandLineOptions): AngularServeOptions;
    platformToMode(platform: string): string;
    modifyOpenURL(url: string, options: AngularServeOptions): string;
    serveProject(options: AngularServeOptions): Promise<ServeDetails>;
}
export declare class AngularServeCLI extends ServeCLI<AngularServeOptions> {
    readonly name: string;
    readonly pkg: string;
    readonly program: string;
    readonly prefix: string;
    readonly script: string;
    protected stdoutFilter(line: string): boolean;
    protected buildArgs(options: AngularServeOptions): Promise<string[]>;
    protected serveOptionsToNgArgs(options: AngularServeOptions): Promise<string[]>;
    protected buildArchitectCommand(options: AngularServeOptions): string[];
}
